blob: 6c38a7637744e576428fec89b449023e095155c0 [file] [log] [blame]
Stefano Briviod1f1b9c2018-03-06 22:16:27 +01001#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
Stefano Brivioa41c7892018-03-17 02:31:42 +01004# Check that route PMTU values match expectations, and that initial device MTU
5# values are assigned correctly
Stefano Briviod1f1b9c2018-03-06 22:16:27 +01006#
7# Tests currently implemented:
8#
Stefano Brivio5e844302018-03-17 02:31:44 +01009# - pmtu_vti4_exception
10# Set up vti tunnel on top of veth, with xfrm states and policies, in two
11# namespaces with matching endpoints. Check that route exception is not
12# created if link layer MTU is not exceeded, then exceed it and check that
13# exception is created with the expected PMTU. The approach described
14# below for IPv6 doesn't apply here, because, on IPv4, administrative MTU
15# changes alone won't affect PMTU
16#
Stefano Brivio36455bd2018-03-17 02:31:41 +010017# - pmtu_vti6_exception
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010018# Set up vti6 tunnel on top of veth, with xfrm states and policies, in two
19# namespaces with matching endpoints. Check that route exception is
20# created by exceeding link layer MTU with ping to other endpoint. Then
21# decrease and increase MTU of tunnel, checking that route exception PMTU
22# changes accordingly
Stefano Brivioa41c7892018-03-17 02:31:42 +010023#
24# - pmtu_vti4_default_mtu
25# Set up vti4 tunnel on top of veth, in two namespaces with matching
26# endpoints. Check that MTU assigned to vti interface is the MTU of the
27# lower layer (veth) minus additional lower layer headers (zero, for veth)
28# minus IPv4 header length
Stefano Brivio35b49422018-03-17 02:31:43 +010029#
30# - pmtu_vti6_default_mtu
31# Same as above, for IPv6
Stefano Brivio719e1212018-03-17 02:31:45 +010032#
33# - pmtu_vti4_link_add_mtu
34# Set up vti4 interface passing MTU value at link creation, check MTU is
35# configured, and that link is not created with invalid MTU values
Stefano Brivio8b6022f2018-03-17 02:31:46 +010036#
37# - pmtu_vti6_link_add_mtu
38# Same as above, for IPv6
Stefano Brivio1fad59e2018-03-17 02:31:47 +010039#
40# - pmtu_vti6_link_change_mtu
41# Set up two dummy interfaces with different MTUs, create a vti6 tunnel
42# and check that configured MTU is used on link creation and changes, and
43# that MTU is properly calculated instead when MTU is not configured from
44# userspace
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010045
Shuah Khan (Samsung OSG)57aefc72018-05-04 16:34:09 -060046# Kselftest framework requirement - SKIP code is 4.
47ksft_skip=4
48
Sabrina Dubrocac81c7012018-08-30 16:01:18 +020049# Some systems don't have a ping6 binary anymore
50which ping6 > /dev/null 2>&1 && ping6=$(which ping6) || ping6=$(which ping)
51
Stefano Brivio36455bd2018-03-17 02:31:41 +010052tests="
Stefano Brivio1fad59e2018-03-17 02:31:47 +010053 pmtu_vti6_exception vti6: PMTU exceptions
54 pmtu_vti4_exception vti4: PMTU exceptions
55 pmtu_vti4_default_mtu vti4: default MTU assignment
56 pmtu_vti6_default_mtu vti6: default MTU assignment
57 pmtu_vti4_link_add_mtu vti4: MTU setting on link creation
58 pmtu_vti6_link_add_mtu vti6: MTU setting on link creation
59 pmtu_vti6_link_change_mtu vti6: MTU changes on link changes"
Stefano Brivio36455bd2018-03-17 02:31:41 +010060
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010061NS_A="ns-$(mktemp -u XXXXXX)"
62NS_B="ns-$(mktemp -u XXXXXX)"
63ns_a="ip netns exec ${NS_A}"
64ns_b="ip netns exec ${NS_B}"
65
Stefano Brivioa41c7892018-03-17 02:31:42 +010066veth4_a_addr="192.168.1.1"
67veth4_b_addr="192.168.1.2"
68veth4_mask="24"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010069veth6_a_addr="fd00:1::a"
70veth6_b_addr="fd00:1::b"
71veth6_mask="64"
72
Stefano Brivioa41c7892018-03-17 02:31:42 +010073vti4_a_addr="192.168.2.1"
74vti4_b_addr="192.168.2.2"
75vti4_mask="24"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010076vti6_a_addr="fd00:2::a"
77vti6_b_addr="fd00:2::b"
78vti6_mask="64"
79
Stefano Brivio1fad59e2018-03-17 02:31:47 +010080dummy6_0_addr="fc00:1000::0"
81dummy6_1_addr="fc00:1001::0"
82dummy6_mask="64"
83
Stefano Brivio36455bd2018-03-17 02:31:41 +010084cleanup_done=1
85err_buf=
86
87err() {
88 err_buf="${err_buf}${1}
89"
90}
91
92err_flush() {
93 echo -n "${err_buf}"
94 err_buf=
95}
96
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010097setup_namespaces() {
Stefano Brivio380e29a2018-03-17 02:31:38 +010098 ip netns add ${NS_A} || return 1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010099 ip netns add ${NS_B}
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100100}
101
102setup_veth() {
Stefano Brivio380e29a2018-03-17 02:31:38 +0100103 ${ns_a} ip link add veth_a type veth peer name veth_b || return 1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100104 ${ns_a} ip link set veth_b netns ${NS_B}
105
Stefano Brivioa41c7892018-03-17 02:31:42 +0100106 ${ns_a} ip addr add ${veth4_a_addr}/${veth4_mask} dev veth_a
107 ${ns_b} ip addr add ${veth4_b_addr}/${veth4_mask} dev veth_b
108
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100109 ${ns_a} ip addr add ${veth6_a_addr}/${veth6_mask} dev veth_a
110 ${ns_b} ip addr add ${veth6_b_addr}/${veth6_mask} dev veth_b
111
112 ${ns_a} ip link set veth_a up
113 ${ns_b} ip link set veth_b up
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100114}
115
Stefano Brivioa41c7892018-03-17 02:31:42 +0100116setup_vti() {
117 proto=${1}
118 veth_a_addr="${2}"
119 veth_b_addr="${3}"
120 vti_a_addr="${4}"
121 vti_b_addr="${5}"
122 vti_mask=${6}
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100123
Stefano Brivioa41c7892018-03-17 02:31:42 +0100124 [ ${proto} -eq 6 ] && vti_type="vti6" || vti_type="vti"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100125
Stefano Brivioa41c7892018-03-17 02:31:42 +0100126 ${ns_a} ip link add vti${proto}_a type ${vti_type} local ${veth_a_addr} remote ${veth_b_addr} key 10 || return 1
127 ${ns_b} ip link add vti${proto}_b type ${vti_type} local ${veth_b_addr} remote ${veth_a_addr} key 10
128
129 ${ns_a} ip addr add ${vti_a_addr}/${vti_mask} dev vti${proto}_a
130 ${ns_b} ip addr add ${vti_b_addr}/${vti_mask} dev vti${proto}_b
131
132 ${ns_a} ip link set vti${proto}_a up
133 ${ns_b} ip link set vti${proto}_b up
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100134
135 sleep 1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100136}
137
Stefano Brivioa41c7892018-03-17 02:31:42 +0100138setup_vti4() {
139 setup_vti 4 ${veth4_a_addr} ${veth4_b_addr} ${vti4_a_addr} ${vti4_b_addr} ${vti4_mask}
140}
141
142setup_vti6() {
143 setup_vti 6 ${veth6_a_addr} ${veth6_b_addr} ${vti6_a_addr} ${vti6_b_addr} ${vti6_mask}
144}
145
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100146setup_xfrm() {
Stefano Brivio5e844302018-03-17 02:31:44 +0100147 proto=${1}
148 veth_a_addr="${2}"
149 veth_b_addr="${3}"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100150
Stefano Brivio5e844302018-03-17 02:31:44 +0100151 ${ns_a} ip -${proto} xfrm state add src ${veth_a_addr} dst ${veth_b_addr} spi 0x1000 proto esp aead "rfc4106(gcm(aes))" 0x0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f 128 mode tunnel || return 1
152 ${ns_a} ip -${proto} xfrm state add src ${veth_b_addr} dst ${veth_a_addr} spi 0x1001 proto esp aead "rfc4106(gcm(aes))" 0x0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f 128 mode tunnel
153 ${ns_a} ip -${proto} xfrm policy add dir out mark 10 tmpl src ${veth_a_addr} dst ${veth_b_addr} proto esp mode tunnel
154 ${ns_a} ip -${proto} xfrm policy add dir in mark 10 tmpl src ${veth_b_addr} dst ${veth_a_addr} proto esp mode tunnel
155
156 ${ns_b} ip -${proto} xfrm state add src ${veth_a_addr} dst ${veth_b_addr} spi 0x1000 proto esp aead "rfc4106(gcm(aes))" 0x0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f 128 mode tunnel
157 ${ns_b} ip -${proto} xfrm state add src ${veth_b_addr} dst ${veth_a_addr} spi 0x1001 proto esp aead "rfc4106(gcm(aes))" 0x0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f 128 mode tunnel
158 ${ns_b} ip -${proto} xfrm policy add dir out mark 10 tmpl src ${veth_b_addr} dst ${veth_a_addr} proto esp mode tunnel
159 ${ns_b} ip -${proto} xfrm policy add dir in mark 10 tmpl src ${veth_a_addr} dst ${veth_b_addr} proto esp mode tunnel
160}
161
162setup_xfrm4() {
163 setup_xfrm 4 ${veth4_a_addr} ${veth4_b_addr}
164}
165
166setup_xfrm6() {
167 setup_xfrm 6 ${veth6_a_addr} ${veth6_b_addr}
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100168}
169
170setup() {
Shuah Khan (Samsung OSG)57aefc72018-05-04 16:34:09 -0600171 [ "$(id -u)" -ne 0 ] && echo " need to run as root" && return $ksft_skip
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100172
Stefano Brivio36455bd2018-03-17 02:31:41 +0100173 cleanup_done=0
174 for arg do
175 eval setup_${arg} || { echo " ${arg} not supported"; return 1; }
176 done
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100177}
178
179cleanup() {
Stefano Brivio36455bd2018-03-17 02:31:41 +0100180 [ ${cleanup_done} -eq 1 ] && return
Sabrina Dubroca0a286af2018-09-17 15:30:06 +0200181 ip netns del ${NS_A} 2> /dev/null
182 ip netns del ${NS_B} 2> /dev/null
Stefano Brivio36455bd2018-03-17 02:31:41 +0100183 cleanup_done=1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100184}
185
186mtu() {
187 ns_cmd="${1}"
188 dev="${2}"
189 mtu="${3}"
190
191 ${ns_cmd} ip link set dev ${dev} mtu ${mtu}
192}
193
Stefano Briviof2c929f2018-03-17 02:31:40 +0100194mtu_parse() {
195 input="${1}"
196
197 next=0
198 for i in ${input}; do
199 [ ${next} -eq 1 ] && echo "${i}" && return
200 [ "${i}" = "mtu" ] && next=1
201 done
202}
203
Stefano Brivioa41c7892018-03-17 02:31:42 +0100204link_get() {
205 ns_cmd="${1}"
206 name="${2}"
207
208 ${ns_cmd} ip link show dev "${name}"
209}
210
211link_get_mtu() {
212 ns_cmd="${1}"
213 name="${2}"
214
215 mtu_parse "$(link_get "${ns_cmd}" ${name})"
216}
217
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100218route_get_dst_exception() {
Stefano Brivio822d2f82018-03-17 02:31:39 +0100219 ns_cmd="${1}"
220 dst="${2}"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100221
Stefano Brivio822d2f82018-03-17 02:31:39 +0100222 ${ns_cmd} ip route get "${dst}"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100223}
224
225route_get_dst_pmtu_from_exception() {
Stefano Brivio822d2f82018-03-17 02:31:39 +0100226 ns_cmd="${1}"
227 dst="${2}"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100228
Stefano Briviof2c929f2018-03-17 02:31:40 +0100229 mtu_parse "$(route_get_dst_exception "${ns_cmd}" ${dst})"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100230}
231
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200232check_pmtu_value() {
233 expected="${1}"
234 value="${2}"
235 event="${3}"
236
237 [ "${expected}" = "any" ] && [ -n "${value}" ] && return 0
238 [ "${value}" = "${expected}" ] && return 0
239 [ -z "${value}" ] && err " PMTU exception wasn't created after ${event}" && return 1
240 [ -z "${expected}" ] && err " PMTU exception shouldn't exist after ${event}" && return 1
241 err " found PMTU exception with incorrect MTU ${value}, expected ${expected}, after ${event}"
242 return 1
243}
244
Stefano Brivio5e844302018-03-17 02:31:44 +0100245test_pmtu_vti4_exception() {
246 setup namespaces veth vti4 xfrm4 || return 2
247
248 veth_mtu=1500
249 vti_mtu=$((veth_mtu - 20))
250
251 # SPI SN IV ICV pad length next header
252 esp_payload_rfc4106=$((vti_mtu - 4 - 4 - 8 - 16 - 1 - 1))
253 ping_payload=$((esp_payload_rfc4106 - 28))
254
255 mtu "${ns_a}" veth_a ${veth_mtu}
256 mtu "${ns_b}" veth_b ${veth_mtu}
257 mtu "${ns_a}" vti4_a ${vti_mtu}
258 mtu "${ns_b}" vti4_b ${vti_mtu}
259
260 # Send DF packet without exceeding link layer MTU, check that no
261 # exception is created
262 ${ns_a} ping -q -M want -i 0.1 -w 2 -s ${ping_payload} ${vti4_b_addr} > /dev/null
263 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti4_b_addr})"
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200264 check_pmtu_value "" "${pmtu}" "sending packet smaller than PMTU (IP payload length ${esp_payload_rfc4106})" || return 1
Stefano Brivio5e844302018-03-17 02:31:44 +0100265
266 # Now exceed link layer MTU by one byte, check that exception is created
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200267 # with the right PMTU value
Stefano Brivio5e844302018-03-17 02:31:44 +0100268 ${ns_a} ping -q -M want -i 0.1 -w 2 -s $((ping_payload + 1)) ${vti4_b_addr} > /dev/null
269 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti4_b_addr})"
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200270 check_pmtu_value "${esp_payload_rfc4106}" "${pmtu}" "exceeding PMTU (IP payload length $((esp_payload_rfc4106 + 1)))"
Stefano Brivio5e844302018-03-17 02:31:44 +0100271}
272
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100273test_pmtu_vti6_exception() {
Stefano Brivio5e844302018-03-17 02:31:44 +0100274 setup namespaces veth vti6 xfrm6 || return 2
Stefano Brivio36455bd2018-03-17 02:31:41 +0100275 fail=0
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100276
277 # Create route exception by exceeding link layer MTU
278 mtu "${ns_a}" veth_a 4000
279 mtu "${ns_b}" veth_b 4000
Stefano Brivioa41c7892018-03-17 02:31:42 +0100280 mtu "${ns_a}" vti6_a 5000
281 mtu "${ns_b}" vti6_b 5000
Sabrina Dubrocac81c7012018-08-30 16:01:18 +0200282 ${ns_a} ${ping6} -q -i 0.1 -w 2 -s 60000 ${vti6_b_addr} > /dev/null
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100283
284 # Check that exception was created
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200285 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti6_b_addr})"
286 check_pmtu_value any "${pmtu}" "creating tunnel exceeding link layer MTU" || return 1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100287
288 # Decrease tunnel MTU, check for PMTU decrease in route exception
Stefano Brivioa41c7892018-03-17 02:31:42 +0100289 mtu "${ns_a}" vti6_a 3000
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200290 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti6_b_addr})"
291 check_pmtu_value "3000" "${pmtu}" "decreasing tunnel MTU" || fail=1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100292
293 # Increase tunnel MTU, check for PMTU increase in route exception
Stefano Brivioa41c7892018-03-17 02:31:42 +0100294 mtu "${ns_a}" vti6_a 9000
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200295 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti6_b_addr})"
296 check_pmtu_value "9000" "${pmtu}" "increasing tunnel MTU" || fail=1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100297
Stefano Brivio36455bd2018-03-17 02:31:41 +0100298 return ${fail}
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100299}
300
Stefano Brivioa41c7892018-03-17 02:31:42 +0100301test_pmtu_vti4_default_mtu() {
302 setup namespaces veth vti4 || return 2
303
304 # Check that MTU of vti device is MTU of veth minus IPv4 header length
305 veth_mtu="$(link_get_mtu "${ns_a}" veth_a)"
306 vti4_mtu="$(link_get_mtu "${ns_a}" vti4_a)"
307 if [ $((veth_mtu - vti4_mtu)) -ne 20 ]; then
308 err " vti MTU ${vti4_mtu} is not veth MTU ${veth_mtu} minus IPv4 header length"
309 return 1
310 fi
311}
312
Stefano Brivio35b49422018-03-17 02:31:43 +0100313test_pmtu_vti6_default_mtu() {
314 setup namespaces veth vti6 || return 2
315
316 # Check that MTU of vti device is MTU of veth minus IPv6 header length
317 veth_mtu="$(link_get_mtu "${ns_a}" veth_a)"
318 vti6_mtu="$(link_get_mtu "${ns_a}" vti6_a)"
319 if [ $((veth_mtu - vti6_mtu)) -ne 40 ]; then
320 err " vti MTU ${vti6_mtu} is not veth MTU ${veth_mtu} minus IPv6 header length"
321 return 1
322 fi
323}
324
Stefano Brivio719e1212018-03-17 02:31:45 +0100325test_pmtu_vti4_link_add_mtu() {
326 setup namespaces || return 2
327
328 ${ns_a} ip link add vti4_a type vti local ${veth4_a_addr} remote ${veth4_b_addr} key 10
329 [ $? -ne 0 ] && err " vti not supported" && return 2
330 ${ns_a} ip link del vti4_a
331
332 fail=0
333
334 min=68
Sabrina Dubroca902b5412018-08-30 16:01:17 +0200335 max=$((65535 - 20))
Stefano Brivio719e1212018-03-17 02:31:45 +0100336 # Check invalid values first
337 for v in $((min - 1)) $((max + 1)); do
338 ${ns_a} ip link add vti4_a mtu ${v} type vti local ${veth4_a_addr} remote ${veth4_b_addr} key 10 2>/dev/null
339 # This can fail, or MTU can be adjusted to a proper value
340 [ $? -ne 0 ] && continue
341 mtu="$(link_get_mtu "${ns_a}" vti4_a)"
342 if [ ${mtu} -lt ${min} -o ${mtu} -gt ${max} ]; then
343 err " vti tunnel created with invalid MTU ${mtu}"
344 fail=1
345 fi
346 ${ns_a} ip link del vti4_a
347 done
348
349 # Now check valid values
350 for v in ${min} 1300 ${max}; do
351 ${ns_a} ip link add vti4_a mtu ${v} type vti local ${veth4_a_addr} remote ${veth4_b_addr} key 10
352 mtu="$(link_get_mtu "${ns_a}" vti4_a)"
353 ${ns_a} ip link del vti4_a
354 if [ "${mtu}" != "${v}" ]; then
355 err " vti MTU ${mtu} doesn't match configured value ${v}"
356 fail=1
357 fi
358 done
359
360 return ${fail}
361}
362
Stefano Brivio8b6022f2018-03-17 02:31:46 +0100363test_pmtu_vti6_link_add_mtu() {
364 setup namespaces || return 2
365
366 ${ns_a} ip link add vti6_a type vti6 local ${veth6_a_addr} remote ${veth6_b_addr} key 10
367 [ $? -ne 0 ] && err " vti6 not supported" && return 2
368 ${ns_a} ip link del vti6_a
369
370 fail=0
371
Stefano Brivio5a643c82018-04-26 19:41:02 +0200372 min=68 # vti6 can carry IPv4 packets too
Stefano Brivio8b6022f2018-03-17 02:31:46 +0100373 max=$((65535 - 40))
374 # Check invalid values first
375 for v in $((min - 1)) $((max + 1)); do
376 ${ns_a} ip link add vti6_a mtu ${v} type vti6 local ${veth6_a_addr} remote ${veth6_b_addr} key 10 2>/dev/null
377 # This can fail, or MTU can be adjusted to a proper value
378 [ $? -ne 0 ] && continue
379 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
380 if [ ${mtu} -lt ${min} -o ${mtu} -gt ${max} ]; then
381 err " vti6 tunnel created with invalid MTU ${v}"
382 fail=1
383 fi
384 ${ns_a} ip link del vti6_a
385 done
386
387 # Now check valid values
Stefano Brivio5a643c82018-04-26 19:41:02 +0200388 for v in 68 1280 1300 $((65535 - 40)); do
Stefano Brivio8b6022f2018-03-17 02:31:46 +0100389 ${ns_a} ip link add vti6_a mtu ${v} type vti6 local ${veth6_a_addr} remote ${veth6_b_addr} key 10
390 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
391 ${ns_a} ip link del vti6_a
392 if [ "${mtu}" != "${v}" ]; then
393 err " vti6 MTU ${mtu} doesn't match configured value ${v}"
394 fail=1
395 fi
396 done
397
398 return ${fail}
399}
400
Stefano Brivio1fad59e2018-03-17 02:31:47 +0100401test_pmtu_vti6_link_change_mtu() {
402 setup namespaces || return 2
403
404 ${ns_a} ip link add dummy0 mtu 1500 type dummy
405 [ $? -ne 0 ] && err " dummy not supported" && return 2
406 ${ns_a} ip link add dummy1 mtu 3000 type dummy
407 ${ns_a} ip link set dummy0 up
408 ${ns_a} ip link set dummy1 up
409
410 ${ns_a} ip addr add ${dummy6_0_addr}/${dummy6_mask} dev dummy0
411 ${ns_a} ip addr add ${dummy6_1_addr}/${dummy6_mask} dev dummy1
412
413 fail=0
414
415 # Create vti6 interface bound to device, passing MTU, check it
416 ${ns_a} ip link add vti6_a mtu 1300 type vti6 remote ${dummy6_0_addr} local ${dummy6_0_addr}
417 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
418 if [ ${mtu} -ne 1300 ]; then
419 err " vti6 MTU ${mtu} doesn't match configured value 1300"
420 fail=1
421 fi
422
423 # Move to another device with different MTU, without passing MTU, check
424 # MTU is adjusted
Stefano Brivio1fad59e2018-03-17 02:31:47 +0100425 ${ns_a} ip link set vti6_a type vti6 remote ${dummy6_1_addr} local ${dummy6_1_addr}
426 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
427 if [ ${mtu} -ne $((3000 - 40)) ]; then
428 err " vti MTU ${mtu} is not dummy MTU 3000 minus IPv6 header length"
429 fail=1
430 fi
431
432 # Move it back, passing MTU, check MTU is not overridden
Stefano Brivio1fad59e2018-03-17 02:31:47 +0100433 ${ns_a} ip link set vti6_a mtu 1280 type vti6 remote ${dummy6_0_addr} local ${dummy6_0_addr}
434 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
435 if [ ${mtu} -ne 1280 ]; then
436 err " vti6 MTU ${mtu} doesn't match configured value 1280"
437 fail=1
438 fi
439
440 return ${fail}
441}
442
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100443trap cleanup EXIT
444
Stefano Brivio36455bd2018-03-17 02:31:41 +0100445exitcode=0
446desc=0
447IFS="
448"
449for t in ${tests}; do
450 [ $desc -eq 0 ] && name="${t}" && desc=1 && continue || desc=0
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100451
Stefano Brivio36455bd2018-03-17 02:31:41 +0100452 (
453 unset IFS
454 eval test_${name}
455 ret=$?
456 cleanup
457
458 if [ $ret -eq 0 ]; then
459 printf "TEST: %-60s [ OK ]\n" "${t}"
460 elif [ $ret -eq 1 ]; then
461 printf "TEST: %-60s [FAIL]\n" "${t}"
462 err_flush
463 exit 1
464 elif [ $ret -eq 2 ]; then
465 printf "TEST: %-60s [SKIP]\n" "${t}"
466 err_flush
467 fi
468 )
469 [ $? -ne 0 ] && exitcode=1
470done
471
472exit ${exitcode}